/*
 * file iterxy.c 
 *
 * Author:  Bob Sawyer
 *
 * Purpose: Take a starting point (x,y) and apply the function xy() to
 *          get a new point (x,y).  Continue iterating xy() to generate
 *          and plot an infinite sequence of points. 
 */

#define CLO 0
#define CHI 417
#define RLO 0
#define RHI 347 

main(argc, argv)
int argc;
char *argv[];
	{
	double atof();
    double x, xlo, xhi, y, ylo, yhi, a, b;
	int t, id;
	
    if (argc != 10)
    	{
    	printf("Usage:  iterxy id xlo xhi ylo yhi a b x0 y0");
    	exit();
    	}
    else
    	{
    	id = atoi(argv[1]);
		xlo = atof(argv[2]);
		xhi = atof(argv[3]);
		ylo = atof(argv[4]);
		yhi = atof(argv[5]);        
    	a = atof(argv[6]);
    	b = atof(argv[7]);
    	x = atof(argv[8]);
    	y = atof(argv[9]);
    	}

	gmode();
	disp(1);
	gpage(1);
	clrscr();
  	gframe();

	t = 0;
	while (! csts())	
 		{
 		drawxy(id, x, y, xlo, xhi, ylo, yhi);
 		xy(t, &x, &y, a, b);
 		++t;
    	}
    tmode();
    }


gframe()
	{
	int clo, chi, rlo, rhi;

	clo = CLO;
	chi = CHI;
	rlo = RLO;
	rhi = RHI;

	move(clo, rlo);
	dline(chi, rlo);
	dline(chi, rhi);
	dline(clo, rhi);
	dline(clo, rlo);
	}
	

                             /* draw line if id != 0, else plot point */
drawxy(id, x, y, xlo, xhi, ylo, yhi) 
double x, y, xlo, xhi, ylo, yhi;
int id;
	{
	int c, clo, chi, r, rlo, rhi;
	clo = CLO;
	chi = CHI;
	rlo = RLO;
	rhi = RHI;

	c = clo + (chi - clo) * (x - xlo) / (xhi - xlo);
	r = rlo + (rhi - rlo) * (yhi - y) / (yhi - ylo);

	if (r<=rhi && r>=rlo && c<=chi && c>=clo)
		{
		if (id != 0)
			dline(c, r);
		else
			plot(c, r);
			move(c, r);
		}	
	}

xy(t, px, py, a, b)
int t;
double *px, *py, a, b;
	{
	double x, y;
    
    x = *px;
	y = *py;

	*px = y - a*x*x -1;
	*py = b*x;
	}

